;Baustelle

;OSD-Zeichengenerator mit Mega8 @ 16MHz

;Idee und Zeichensatz nach Analyse eines Projekts von Benedikt (benedikt83 t gmx.net)


.include "m8def.inc"

;#define zapp                ;schaltet das Zappen ein 

;digitale Steuereingnge
.equ kan8=5                 ;Eingang des Kanal 8 zur Unterdrckung von Zapp
.equ poweroff=6             ;Eingang Stromausfall
.equ test=7                 ;Anzeige Zeichensatz, Senden von Zapp-hoch


;PortB                  ;dient komplett der Signalerzeugung
.equ icp=0                  ;Eingang Sync-Signal
.equ DOUT=1                 ;Pixeldaten                 \
.equ Sync=2                 ;Vsync Ausgang (entfllt)    } Verbinden
.equ MOSI=3                 ;Pixeldaten                 /
.equ MISO=4                 ;NC (nicht benutzbar)
.equ SCK=5                  ;NC (nicht benutzbar)

.equ clock=16000000         ;Controllertakt
;.equ clock=14745600         ;Controllertakt
.equ Baudrate=2400          ;RS232-Baudrate

;Bildgre und -Parameter
.equ XSize=32               ;Bildgre in X Richtung in Zeichen (nicht verndern!!)
.equ Dummy=2                ;leere Textzeilen am oberen Bildrand
.equ Zeilen=10              ;Anzahl der sichtbaren Textzeilen
.equ hs_toleranz=50         ;erlaubte Toleranz im Abstand der H-Sync-Impulse
.equ XStart=24              ;Breite des linken Randes
.equ Height=23              ;Zeichenhhe

#define LCD                 ;Zeichen 128-135: Balkenanzeige
#define HOR_FILL            ;Lcken zwischen den Zeichen fllen

;ADC
.equ mux_=(1<<refs0)|(1<<adlar) ;Vcc als Referenz, 8-Bit-Mode
.equ adcstart=(1<<aden)|(1<<adfr)|(1<<adsc) ;Free-Run-Mode


;berechnete Konstanten:
.equ YSize=Zeilen               ;nderung geplant
.equ ubrr_=clock/16/baudrate-1  ;Baudrate berechnen
.equ z_takte=clock/15625        ;Anzahl der Takte je TV-Zeile

.dseg
duram:  .byte XSize*dummy   ;leere Dummy-RAM-Zeilen (zur Unterdrckung 
                            ;der entstehenden V-Sync-Fehler
DDRAM:  .byte XSize*YSize   ;DDRAM (Bildschirmspeicher fr Text)
DDRAMend:                   ;Ende des Bildschirmspeichers
rxptr:  .byte 2             ;Schreibpointer auf DDRAM (UART-RX)
ddptr:  .byte 2             ;Schreibpointer auf DDRAM (interne Prints)
izsalt: .byte 2             ;alter ISP-Zeitstempel
zhalt:  .byte 1             ;Siko ZH-Pointer (Pixelzeile in Zeichen)
xalt:   .byte 2             ;Sicherung X-Pointer
adwert: .byte 4             ;4 ADC-Messwerte
tmpmath:.byte 4             ;temporr fr Zahlendarstellung
tas:    .byte 1             ;Tastenstatus
tfld:   .byte 1             ;Tastenflag drcken
tfll:   .byte 1             ;Tastenflag loslassen
pz0:    .byte 1             ;Prellzhler Bit 0
pz1:    .byte 1             ;Prellzhler Bit 1


;Exklusivregister fr Interrupt:
.def regsave=r2             ;SREG-Sicherung
.def spian=r3               ;Konstanten zum schnellen
.def spiaus=r4              ;Schalten des bildgebenden Ports
.def X_Cnt=r5               ;Zeichenzhler in der Zeile
.def itl=r6                 ;temp in ISR low
.def ith=r7                 ;temp in ISR high

.def tempi=r16              ;temporr im Interrupt
.def Y_Cnt=r17              ;Zextzeilenzhler
.def C_Cnt=r18              ;Zeichenhhenzhler
;zustzlich: X (gesichert) und Z (gesichert)

;Sonstige Register, fr Hauptprogramm frei:
.def zeit=r8                ;Timeout fr Bildausfall
.def null=r9                ;immer 0
.def svt=r10                ;Sekunden-Vorteiler
.def seku=r11               ;Sekunde (Debug-Dummy)
.def task=r12               ;Taskscheibe

.def tmp=r22                ;kurzzeitig temporr
.def flags=r23              ;einige Semaphores
    .equ zeigmode=7             ;Status, Modus fr Portwerte anzeigen
    .equ zeigwert=6             ;Status, Portwerte anzeigen

    .equ bildfertig=2           ;Job, Bild ist fertig, jetzt ist etwas Zeit
    .equ neu4ms=1               ;Job, Timer1 ist bergelaufen (alle 4ms)
    .equ neusek=0               ;Job, (etwa eine) neue Sekunde

.def wl=r24                 ;Working low
.def wh=r25                 ;Working high
;zustzlich: Y

;-----------------------------------------------------------------------------
.cseg
.org 0
.org 0              ;Reset- und Interrupt-Vektoren AT-Mega 8
 rjmp RESET         ;Reset Handler
 rjmp nix;EXT_INT0      ;IRQ0 Handler
 rjmp nix;EXT_INT1      ;IRQ1 Handler
 rjmp nix;TIM2_COMP     ;Timer2 Compare Handler
 rjmp nix;TIM2_OVF      ;Timer2 Overflow Handler
 rjmp TIM1_CAPT     ;Timer1 Capture Handler
 rjmp nix;TIM1_COMPA    ;Timer1 CompareA Handler
 rjmp nix;TIM1_COMPB    ;Timer1 CompareB Handler
 rjmp TIM1_OVF      ;Timer1 Overflow Handler
 rjmp nix;TIM0_OVF      ;Timer0 Overflow Handler
 rjmp nix;SPI_STC       ;SPI Transfer Complete Handler
 rjmp nix;USART_RXC     ;USART RX Complete Handler
 rjmp nix;USART_UDRE    ;UDR Empty Handler
 rjmp nix;USART_TXC     ;USART TX Complete Handler
 rjmp nix;ADCC          ;ADC Conversion Complete Handler
 rjmp nix;EE_RDY        ;EEPROM Ready Handler
 rjmp nix;ANA_COMP      ;Analog Comparator Handler
 rjmp nix;TWSI          ;Two-wire Serial Interface Handler
 rjmp nix;SPM_RDY       ;Store Program Memory Ready Handler
nix: rjmp nix       ;Falle fr Programmierfehler...

.include "pr_txt.inc"       ;Ausgabe von ASCII-Texten
.include "pr_debug.inc"     ;Ausgabe als HEX oder BIN
.include "pr_i2a8.inc"      ;Ausgabe von Integer 8 Bit
.include "pr_i2a16.inc"     ;Ausgabe von Integer 16 Bit


.macro print ;Zeichen als Byte, Anzahl als Byte (Beides als Konstanten)
                        ;Gibt ein Zeichen mehrfach an LCD aus
 push wh
 ldi wh,@1                  ;Anzahl als Konstante
 ldi tmp,@0                 ;Das Zeichen als Konstante
 rcall lcd_data             ;an LCD ausgeben
 dec wh                     ;Anzahl runter
 brne pc-2                  ;nochmal, wenn nicht 0...
 pop wh
.endmacro

.macro locate ;Zeile (1..10),Spalte (0..31) als Konstanten
 ldi tmp,low(ddram+(@0-1)*32+@1)    ;Ausgabezeiger
 sts ddptr,tmp                      ;L
 ldi tmp,high(ddram+(@0-1)*32+@1)   ;und H
 sts ddptr+1,tmp                    ;positionieren
.endmacro


TIM1_OVF:           ;ISR, fr Steuerungs-Timing
 in regsave,sreg            ;SREG sichern
 sbr flags,1<<neu4ms        ;Job anmelden
 out sreg,regsave           ;SREG wiederherstellen
 reti                       ;fertig...

;-----------------------------------------------------------------------------

TIM1_CAPT:          ;ISR, Bildbeginn
 in regsave, sreg           ;SREG sichern
 push zl
 push zh
 push xl
 push xh
; mov tempi, ZH              ;Pixelzeile zwischenspeichern
 in itl,icr1l               ;Zeitstempel 
 in ith,icr1h               ;einlesen
 lds zl,izsalt              ;alten Zeitstempel
 lds zh,izsalt+1            ;holen
 sts izsalt,itl             ;neuen Zeitstempel 
 sts izsalt+1,ith           ;sichern
 sub itl,zl                 ;Differenz (H-Sync-Impulsabstand)
 sbc ith,zh                 ;ermitteln
 ldi zl,low(z_takte-hs_toleranz)    ;vermuteten H-Sync-Impulsabstand
 ldi zh,high(z_takte-hs_toleranz)   ;abzglich Fangtoleranz
 sub itl,zl                 ;von ermittelten H-Sync-Impulsabstand
 sbc ith,zh                 ;subtrahieren (Fang-Toleranz bleibt brig)
 ldi zl,low(2*hs_toleranz)  ;doppelte Fang-Toleranz
 ldi zh,high(2*hs_toleranz) ;als Fangbereich
 cp itl,zl                  ;liegt der H-Sync-Impulsabstand
 cpc ith,zh                 ;noch im Fangbereich?
 brlo kein_vsync            ;ja, es war kein Sync-Impuls

Bildbeginn:
 clr Y_Cnt                  ;Textzeilenzhler auf 0
 ldi XL, low(DuRAM)         ;X-Pointer auf
 ldi XH, high(DuRAM)        ;Beginn des Bildschirmspeichers
 sts xalt,xl                ;und
 sts xalt+1,xh              ;sichern
Bildbeginn1:
 rjmp exit_int              ;fertig...

kein_vsync:
 cpi Y_Cnt,YSize+dummy      ;Bildbereich zu Ende?
 brsh bildbeginn1           ;ja...

 ldi zl,xstart              ;Warteschleife
rand_links:
 dec zl                     ;fr linken 
 brne rand_links            ;Bildrand

comp:
 lds xl,xalt                ;gesicherten Pointer auf Zeilenbeginn im
 lds xh,xalt+1              ;Bildschirmspeicher holen
 lds ZH,zhalt               ;gesicherten Pixelzeilenzhler holen
 ldi tempi, XSize
 mov X_Cnt, tempi
hloop:              ;Loop fr 1 Zeile
 ld ZL,X+                   ;ASCII aus RAM lesen    2
 lpm tempi,Z                ;Byte aus CGROM lesen   3
 out DDRB,spiaus            ;SPI aus, Port an       1
 out SPDR,tempi             ;Byte ausgeben          1
 out DDRB,spian             ;SPI an, Port aus       1
#ifdef HOR_FILL
 sbrs tempi,0               ;Fllpixel setzen       1
 cbi PORTB,DOUT             ;                       1,5
 sbrc tempi,0               ;                       1
 sbi PORTB,DOUT             ;                       1,5
#else
 nop                        ;                       1
 nop                        ;                       1
 nop                        ;                       1
 nop                        ;                       1
 nop                        ;                       1
#endif
 nop                        ;                       1
 nop                        ;                       1
 nop                        ;                       1
 nop                        ;                       1
 nop                        ;                       1
 nop                        ;                       1
 nop                        ;                       1
 dec X_Cnt                  ;                       1
 brne hloop                 ;                       2
                            ;                     =24, (18)
                            ;also 16 (fr 1 Byte) + Pause dazwischen
 nop
 nop
 nop
 nop
 nop
 nop
 out DDRB,spiaus            ;SPI abschalten
 cbi PORTB,DOUT             ;Bild: schwarz
 dec C_Cnt                  ;Zhler fr Zeichenhhe erniedrigen
 breq skipcloop             ;eine Textzeile fertig ausgegeben? - ja...
;-----
 mov tempi,C_Cnt            ;Kopie
 sbrc tempi,0               ;
 inc ZH                     ;Nein -> Bilddatenadresse fr nchste Pixelzeile laden und
 cpi zh,high(cgrom*2)+9
 brlo z_hoehe
 ldi zh,high(cgrom*2)+8
z_hoehe:
 sts zhalt,zh               ;Pixelzeilenzhler fr nchste Runde sichern
; subi XL,low(XSize)         ;Textadresse wieder an Anfang der Textzeile setzen
; sbci XH,high(XSize)
 rjmp exit_int

skipcloop:                  ;Alles fr neue Textzeile einrichten
 sts xalt,xl                ;vernderte Text-Adresse im
 sts xalt+1,xh              ;Bildschirmspeicher sichern
 ldi ZH,high(cgrom*2)       ;Pointer auf erste Pixelzeile im CGROM setzen
 sts zhalt,zh               ;Pixelzeilenzhler fr nchste Runde sichern
 ldi C_Cnt,Height           ;Zeichenhhen Counter laden
 inc Y_Cnt                  ;Zeilencounter erhhen
 
 cpi Y_Cnt,YSize+dummy      ;Bildbereich zu Ende?
 brne exit_int              ;nein...
 sbr flags,1<<bildfertig    ;ja, anmelden, denn jetzt ist Zeit fr weitere 
                            ;Dinge, die lnger dauern drfen, als die knappe
                            ;Zeit zwischen zwei TV-Zeilen

exit_int:
 pop xh
 pop xl
 pop zh
 pop zl
 out sreg,regsave           ;SREG wiederherstellen
 reti                       ;fertig...

;-----------------------------------------------------------------------------

Reset:              ;Programmstart, Initialisierung
;I/O-Bereich initialisieren:
 ldi wl,low(RAMEND)        ;Stackpointer initialisieren
 out SPL,wl
 ldi wl,high(RAMEND)
 out SPH,wl
 clr null                   ;immer 0

 ser wl                     ;Pullups ungenutzter Portpins einschalten
 out portd,wl
 ldi wl,0b00110000          ;PullUps PC4 und PC5 an
 out portc,wl               ;PortC ein

 out portb,null             ;PortB (Video-Port) erstmal alle Bits auf H

 ldi wl,(1<<Sync)|(1<<MOSI) ;Pixelports
 mov spian,wl               ;definieren und
 out DDRB,wl                ;als Ausgng schalten

 ldi wl,(1<<Sync)|(1<<DOUT) ;Schwarzpegel auerhalb des Textes
 mov spiaus,wl              ;vorbereiten

 ldi wl,(1<<SPE)|(1<<MSTR)|(1<<CPHA)    ;SPI als Master mit max.
 out SPCR,wl                ;Takt einschalten
 sbi SPSR,SPI2X             ;SPI-Taktverdopplung aktivieren

 ldi wl,(1<<ices1)|1        ;Steigende ICP-Flanke bei 16MHz: 15,625kHz
 out TCCR1B,wl

;ldi wl,(1<<OCIE1A)          ;CompareA Interrupt: Beginn der Datenausgabe
;out timsk, wl

 ldi wl,(1<<ticie1)|(1<<toie1);ICP-Interrupt: Beginn der Datenausgabe
 out timsk,wl               ;berlauf-Interrupt: 244 Hz (4,1ms)

 ldi wl,high(ubrr_)         ;Baudrate einstellen
 out UBRRH,wl
 ldi wl,low(ubrr_)
 out UBRRL,wl
 ldi wl,(1<<RXEN)|(1<<txen) ;RX und TX aktivieren
 out UCSRB,wl

 ldi wl,mux_                ;ADC-Referenz 
 out admux,wl               ;einstellen
 ldi wl,adcstart            ;ADC
 out adcsr,wl               ;starten

 sbi ddrd,pd1               ;UART-TX als Ausgang
 
;Variablen initialisieren:
 clr flags                  ;stabile Startbedingungen
 sts tas,null               ;definierte Startbedingungen
 sts tfld,null              ;fr Entprellung
 sts tfll,null              ;
 sts pz0,null               ;
 sts pz1,null               ;

 rcall scnclr               ;DD-RAM lschen

 sbic pind,7                ;Debug-Schalter ein? - ja, Zeichensatz anzeigen...
 rjmp reset1                ;nein, Bildschirm leer lassen
 ;Zeichensatz anzeigen
 ldi YL,low(DDRAM)          ;DD-RAM (Text-Bildschirmspeicher)
 ldi YH,high(DDRAM)
clrloop:
 st Y+,wl                   ;mit ASCII-Zeichensatz fllen (Demo, Test)
 inc wl
 brne clrloop
reset1:

 ldi YL,low(DDRAM)          ;DD-RAM (Text-Bildschirmspeicher)
 ldi YH,high(DDRAM)         ;auf Start
 sts ddptr,yl               ;initialisierte Pointer auf
 sts ddptr+1,yh             ;DDRAM sichern (int. Print)
 ldi yh,high(DDRAMend-32)   ;Beginn Zeile fr
 ldi yl,low(DDRAMend-32)    ;Kanalanzeige (UART)
 sts rxptr,yl               ;initialisierte Pointer auf
 sts rxptr+1,yh             ;DDRAM sichern (UART-RX)

 ldi XL,low(DuRAM)          ;X-Pointer (Bildausgabe) erstmal auf
 ldi XH,high(DuRAM)         ;Start des Bildschirmspeichers
 
 ldi wl,1<<se               ;Sleepmode IDLE
 out mcucr,wl               ;einschalten
 sei

;----------------------------------------------------------------------------


Mainloop:           ;Hauptprogramm
 sbic UCSRA,RXC             ;Daten im UART Puffer? - nein...
 rjmp rxuart                ;ja...
 sbrc flags,bildfertig      ;ist jetzt Zeit fr andere Dinge? - nein...
 rjmp pipapo                ;ja...
 sbrc flags,neu4ms          ;Timer-berlauf? - nein...
 rjmp vier_ms               ;ja...
 sleep                      ;
 rjmp Mainloop

vier_ms:            ;Zeitzhlung, Aufruf alle 4ms 
 cbr flags,1<<neu4ms        ;Job abmelden
 ;zuerst ADC einlesen:
 push yl                    ;Pointer-Variablen 
 push yh                    ;beschaffen
 in tmp,admux               ;ADC-Quelle der letzten Wandlung holen
 andi tmp,3                 ;Steuerbits ausblenden
 ldi yl,low(adwert)         ;Pointer auf
 ldi yh,high(adwert)        ;ADC-Werte im SRAM
 add yl,tmp                 ;Offset
 adc yh,null                ;dazu
 ld wh,y                    ;alten ADC-Wert holen
 in wl,adch                 ;neuen ADC-Messwert holen
 add wh,wl                  ;beide addieren,
 ror wh                     ;durch 2 teilen
 st y,wh                    ;und wieder sichern
 inc tmp                    ;nchste Messquelle
 andi tmp,3                 ;nur ADC0 bis ADC3 bercksichtigen
 ori tmp,mux_               ;Referenz und Modus wieder dazu,
 out admux,tmp              ;Quelle umschalten
 pop yh                     ;Pointer-Variablen 
 pop yl                     ;entsorgen
 ;ADC ist fertig, nun (nicht ganz genaue) Sekunden hochzhlen
 inc svt                    ;Sekunden-Vorteiler hochzhlen
 brne vier_ms1              ;berlauf? - nein...
;eine Sekunde ist vergangen
 sbr flags,1<<neusek        ;neue Sekunde anmelden
 inc seku                   ;und erhhen

#ifdef zapp         ;nur assemblieren, wenn "zapp" definiert ist
 lds wl,tas                 ;entprellten Status der digitalen Eingnge holen
 sbrs wl,7                  ;Debug-Schalter ein? - ja, Zappen...
 rjmp vier_ms1              ;nein, nicht zappen
 ldi tmp,'+'                ;Hoch-Zapp-Telegramm
 sbrc seku,0                ;jede zweite Sekunde an den
 out udr,tmp                ;Quellenumschalter senden
#endif

vier_ms1:
 inc zeit                   ;Software-Timer hochzhlen
 brne mainloop              ;berlauf? - nein...
;Signal ist seit einer Sekunde ausgefallen
#ifdef zapp         ;nur assemblieren, wenn "zapp" definiert ist
 ldi tmp,'+'                ;Hoch-Zapp-Telegramm 
 sbis pind,kan8             ;auer bei K8 (Port-Direktabfrage, da bei 
                            ;Bildausfall keine Tastenabfrage stattfindet)
 out udr,tmp                ;an den Quellenumschalter senden
#endif
 rjmp mainloop              ;fertig...


rxuart:             ;UART Daten verarbeiten
 push yl                    ;Pointer-Variablen 
 push yh                    ;beschaffen
 in tmp,UDR                 ;Daten abholen
 cpi tmp,31                 ;Steuerzeichen fr Anzeige der Eingnge?
 brne rxuart1               ;nein, zur Ausgabe...
 ;es wurde das Steuerzeichen "ndern des Anzeigemodus" empfangen, nun wird
 ;der Bildschirm gelscht und das Modusflag getoggelt
 subi flags,-64             ;Anzeigemodus hochzhlen
 ldi wl,' '                 ;Leerzeichen zum Fllen,
 ldi YL,low(DuRAM)          ;Bildschirm auer
 ldi YH,high(DuRAM)         ;letzter Zeile lschen
uclsloop:
 st Y+,wl                   ;
 ldi wh,high(DDRAMend-32)   ;Ende vorletzte Zeile
 cpi YL,low(DDRAMend-32)    ;erreicht?
 cpc YH,wh
 brne uclsloop              ;nein...
 rjmp rxuart_e              ;ja, fertig...
rxuart1:
 lds yl,rxptr               ;aktuellen RX-Pointer
 lds yh,rxptr+1             ;auf DDRAM holen
 rcall chrout               ;Zeichen ausgeben...
 sts rxptr,yl               ;vernderte Pointer auf
 sts rxptr+1,yh             ;DDRAM wieder sichern
rxuart_e:
 pop yh                     ;Pointer-Variablen 
 pop yl                     ;entsorgen
 rjmp mainloop              ;fertig...


lcd_data:           ;UP, Text in Bildschirmspeicher schreiben
 push yl                    ;Pointer-Variablen 
 push yh                    ;beschaffen
 lds yl,ddptr               ;aktuellen RX-Pointer
 lds yh,ddptr+1             ;auf DDRAM holen
 rcall chrout
 sts ddptr,yl               ;vernderte Pointer auf
 sts ddptr+1,yh             ;DDRAM wieder sichern
 pop yh                     ;Pointer-Variablen 
 pop yl                     ;entsorgen
 ret                        ;fertig...


chrout:             ;UP, Text in Bildschirmspeicher schreiben
 cpi tmp,32                 ;Steuerzeichen?
 brlo steuerz               ;ja...
 st Y+,tmp                  ;nein, Daten
chrout1:            ;Einsprung aus Enter
 push tmp
 ldi tmp,high(DDRAMend)     ;Ende Bildschirmspeicher
 cpi YL,low(DDRAMend)       ;erreicht?
 cpc YH,tmp
 pop tmp
 brlo chrout_e              ;nein...
 ldi YL,low(DDRAM)          ;ja, Pointer auf
 ldi YH,high(DDRAM)         ;Anfang des DDRAM setzen
chrout_e:
 ret                        ;fertig...

steuerz:            ;das Zeichen ist ein Steuerzeichen...
 cpi tmp,0                  ;0 (nicht vergeben)?
 breq chrout_e              ;nein, fertig...
 cpi tmp,ysize+1            ;eine Zeilen.Nummer (1..10)?
 brsh nixzeile              ;nein...
 ldi wl,32                  ;Textzeilenlnge
 dec tmp                    ;Korrektur
 mul tmp,wl                 ;Offset ermitteln
 ldi yl,low(ddram)          ;Pointer auf
 ldi yh,high(ddram)         ;Anfang Bildschirm
 add yl,r0                  ;Offset
 adc yh,r1                  ;addieren
 rjmp chrout_e              ;fertig...

nixzeile:           ;Zeilen-Nummer war es nicht
 cpi tmp,13                 ;Enter?
 brne nixenter              ;nein...
 ldi tmp,' '                ;ja, Leerzeichen
enterloop:
 st y+,tmp                  ;in den Rest der Zeile schreiben
 mov wl,yl                  ;Kopie 
 andi wl,31                 ;zum Verndern
 brne enterloop             ;Zeile zu Ende? - nein...
 rjmp chrout1               ;ja, auf Ende DDRAM prfen und fertig...

nixenter:           ;Enter war es auch nicht
 cpi tmp,14                 ;aktuelle Zeile lschen?
 brne nixclz                ;nein...
 cbr yl,31                  ;ja, auf Zeilenanfang zurck gehen,
 ldi tmp,' '                ;Leerzeichen
clzloop:
 st y+,tmp                  ;in den Rest der Zeile schreiben
 mov wl,yl                  ;Kopie 
 andi wl,31                 ;zum Verndern
 brne clzloop               ;Zeile zu Ende? - nein...
 sbiw yh:yl,32              ;eine Zeile zurck
 rjmp chrout_e              ;fertig und zurck

nixclz:             ;Zeile Lschen war es nicht
 cpi tmp,15                 ;ganzen Bildschirm lschen?
 brne nixcls                ;nein...
scnclr:             ;Einsprung vom Reset
 ldi wl,' '                 ;Mit Leerzeichen
 ldi YL,low(DuRAM)          ;Dummy-RAM
 ldi YH,high(DuRAM)
clsloop:
 st Y+,wl
 ldi wh,high(DDRAMend)      ;Ende Bildschirmspeicher
 cpi YL,low(DDRAMend)       ;erreicht?
 cpc YH,wh
 brne clsloop
 ldi YL,low(DDRAM)          ;Pointer auf
 ldi YH,high(DDRAM)         ;Anfang des DDRAM setzen
 rjmp chrout_e              ;fertig und zurck
 
nixcls:             ;CLS war es nicht
 ret                        ;fertig...


pipapo:             ;diverse Steueraufgaben, Aufruf alle 20ms
 cbr flags,1<<bildfertig    ;Job als erledigt melden
 clr zeit                   ;Timeout verhindern
 push yl                    ;UART-Empfangpointer
 push yh                    ;sichern
;Digital-Eingnge entprellen 
 in wh,pinc                 ;Port C einlesen (nur PC4 und PC5 interessieren)
 in wl,pind                 ;Port D einlesen (nur PD2 bis PD7)
 bst wh,4                   ;PC4 als
 bld wl,0                   ;PD0 und 
 bst wh,5                   ;PC5 als
 bld wl,1                   ;PD1 interpretieren, nun ist das Byte voll...
 com wl                     ;invertieren, L ist "ein"
 lds wh,tas                 ;Tastenstatus holen
 lds yl,tfld                ;Drckflags holen (fallende Flanke)
 lds yl,tfll                ;loslassflags holen (steigende Flanke)
 lds r0,pz0                 ;Prellzhler Bit 0 holen
 lds r1,pz1                 ;Prellzhler Bit 1 holen
debounce8:          ;UP, das eigentliche Entprellen in vorbereiteten Registern
 ;wl enthlt neuen Wert, wh enthlt entprellten Status
 ;r0 enthlt Prellzhler0, r1 enthlt Prellzhler1
 ;yl enthlt Drckflag, yh enthlt Loslassflag
 ;Der Algorithmus ist von Peter Dannegger bernommen und selbst modifiziert
 ;worden, damit Drcken und Loslassen getrennt erkannt wird.
 eor wl,wh      ;nur nderungen werden H
 and r0,wl      ;Prellzhler unvernderter Tasten lschen (Bit0)
 and r1,wl      ;Prellzhler unvernderter Tasten lschen (Bit1)
 com r0         ;L-Bit zhlen 0,2,->1, 1,3,->0
 eor r1,r0      ;H-Bit zhlen 0,2,->tz1 toggeln
 and wl,r0      ;nderungen nur dann erhalten, wenn im Prellzhler
 and wl,r1      ;beide Bits gesetzt sind (Zhlerstand 3)
 push wl        ;nderungen sichern, um Kopie manipulieren zu drfen
 and wl,wh      ;nur bisher gedrckte Tastenbits bleiben erhalten
 or yh,wl       ;und werden im Loslass-Flag gesetzt
 pop wl         ;gesicherte nderungen zurck holen
 eor wh,wl      ;erhaltene nderungen toggeln alten (gltigen) Tastenstatus
 and wl,wh      ;nur (neu) gedrckte Tastenbits bleiben erhalten
 or yl,wl       ;und zugehrige Bits setzen (gelscht wird nach Abarbeitung)
 sts tas,wh                 ;Tastenstatus sichern
 sts tfld,yh                ;Drckflags sichern (fallende Flanke)
 sts tfll,yl                ;loslassflags sichern (steigende Flanke)
 sts pz0,r0                 ;Prellzhler Bit 0 sichern
 sts pz1,r1                 ;Prellzhler Bit 1 sichern
 ;Alle Variablen sind wieder im SRAM, interessant sind:
 ;tas:  entprellter Tastenstatus (statisch, nur Lesen erlaubt)
 ;tfld: Flanke beim Drcken (fallend)
 ;tfll; Flanke beim Loslassen (steigend)

 inc task                   ;Task-Zhler erhhen
 mov tmp,task               ;Kopie der Tasknummer wegen CPI in temp
 dec tmp

pipapo00:           ;Task 0
 cpi tmp,0                  ;Task 0?
 breq pipapo00a             ;nein...
 rjmp pipapo01              ;nein...
pipapo00a:
;----------- Testausgabe einiger Variablen 
 sbrs flags,zeigwert        ;Anzeige eingeschaltet? - ja...
 rjmp pipapo00b             ;nein...
 locate 2,0                 ;Ausgabe-Position
 printf txtadcin            ;Dummy-Text
 print8s adwert+0           ;ADC-Wert 0
 print ' ',1                ;Leerzeichen
 print8s adwert+1           ;ADC-Wert 1
 print ' ',1                ;Leerzeichen
 print8s adwert+2           ;ADC-Wert 2
 print ' ',1                ;Leerzeichen
 print8s adwert+3           ;ADC-Wert 3
 print 13,1                 ;Rest der Zeile lschen
 printf txtdigin            ;Dummy-Text
 lds wl,tas                 ;entprellten Tastenstatus holen
 printbin wl                ;und hexadezimal ausgeben
 print 13,1                 ;Rest der Zeile lschen
 rjmp zeigvolt              ;Spannung anzeigen...
pipapo00b:

pipapo01:           ;Task 1
 cpi tmp,1                  ;Task 1?
 brne pipapo02              ;nein...
 locate 9,0                 ;Zeile 9
 lds wl,tas
 sbrs wl,poweroff
 rjmp pipapo01a             ;Rest berspringen...
 printf txtkeinstrom        ;
zeigvolt:
 locate 9,27
 lds r0,adwert+0            ;ADC-Wert (1/3 der Akkuspannung) holen
 ldi wl,151                 ;Skalierungsfaktor
 mul r0,wl                  ;auf ZehntelVolt skalieren
 print16 null,r1,1,using    ;Wert mit 1 Kommastelle ausgeben
 print 'V',1                ;Einheitszeichen ausgeben
 rjmp pipapo_e              ;Rest berspringen...
pipapo01a:
 print ' ',26               ;Hinweistext lschen
 sbrc flags,zeigwert        ;Anzeige eingeschaltet? - nein...
 rjmp pipapo01b             ;ja...
 print 13,1                 ;Rest der Zeile auch lschen
pipapo01b:
 rjmp pipapo_e              ;Rest berspringen...

pipapo02:           ;Task 2
;/*
 cpi tmp,2                  ;Task 2?
 brne pipapo03              ;nein...
 ;######################################################### Debug
; locate 1,24
; printbin flags

 clr task                   ;vorerst letzter Task

pipapo03:           ;Task 3
 cpi tmp,3                  ;Task 3?
 brne pipapo04              ;nein...

 rjmp pipapo_e              ;Rest berspringen...

pipapo04:           ;Task 4
 cpi tmp,4                  ;Task 4?
 brne pipapo05              ;nein...

 rjmp pipapo_e              ;Rest berspringen...

pipapo05:           ;Task 5
 cpi tmp,5                  ;Task 5?
 brne pipapo06              ;nein...
 
 rjmp pipapo_e              ;Rest berspringen...

pipapo06:           ;Task 6
 cpi tmp,6                  ;Task 6?
 brne pipapo07              ;nein...
 
 rjmp pipapo_e              ;Rest berspringen...

pipapo07:           ;Task 7
 cpi tmp,7                  ;Task 7?
 brne pipapo08              ;nein...
 
 rjmp pipapo_e              ;Rest berspringen...

pipapo08:           ;Task 8
 cpi tmp,8                  ;Task 8?
 brne pipapo09              ;nein...
 
 rjmp pipapo_e              ;Rest berspringen...

pipapo09:           ;Task 9
 cpi tmp,9                  ;Task 9?
 brne pipapo10              ;nein...
 
 rjmp pipapo_e              ;Rest berspringen...

pipapo10:           ;Task 10
 cpi tmp,10                 ;Task 10?
 brne pipapo11              ;nein...
 
 rjmp pipapo_e              ;Rest berspringen...

pipapo11:           ;Task 11
 cpi tmp,11                 ;Task 11?
 brne pipapo12              ;nein...
 
 rjmp pipapo_e              ;Rest berspringen...

pipapo12:           ;Task 12
 cpi tmp,12                 ;Task 12?
 brne pipapo13              ;nein...
 
 rjmp pipapo_e              ;Rest berspringen...

pipapo13:           ;Task 13
 cpi tmp,13                 ;Task 13?
 brne pipapo14              ;nein...
 
 rjmp pipapo_e              ;Rest berspringen...

pipapo14:           ;Task 14
 cpi tmp,14                 ;Task 14?
 brne pipapo15              ;nein...
 
 rjmp pipapo_e              ;Rest berspringen...

pipapo15:           ;Task 15
 cpi tmp,15                 ;Task 15?
 brne pipapo16              ;nein...
 
 rjmp pipapo_e              ;Rest berspringen...
;*/
pipapo16:           ;Task 16
pipapo_e:
 pop yh                     ;UART-Empfangspointer
 pop yl                     ;rekonstruieren
 rjmp mainloop              ;fertig...



txtkeinstrom:   .db "Stromausfall, Akkubetrieb ",13,0
txtadcin:       .db "ADC-In: ",0,0
txtdigin:       .db "Digital-In: ",0,0


test00:                 ;Label zum Feststellen der Flash-Belegung
.org flashend+1-$480    ;Zeichensatz (+ Dummy) belegt das Ende des Flash-Speichers
cgrom:         ;*** CG ROM Daten *** (8x8 Zeichensatz)
#ifdef LCD
px1:
.db 0x00,0x7E,0x7E,0x6C,0x10,0x38,0x10,0x10,0xFF,0x00,0x00,0x00,0x00,0x00,0x7F,0x99
.db 0x80,0x02,0x18,0x66,0x7F,0x3E,0x00,0x18,0x18,0x18,0x00,0x00,0x00,0x00,0x00,0x00
.db 0x00,0x30,0x6C,0x6C,0x30,0x00,0x38,0x60,0x18,0x60,0x00,0x00,0x00,0x00,0x00,0x06
.db 0x7C,0x30,0x78,0x78,0x1C,0xFC,0x38,0xFC,0x78,0x78,0x00,0x00,0x18,0x00,0x60,0x78
.db 0x7C,0x30,0xFC,0x3C,0xF8,0xFE,0xFE,0x3C,0xCC,0x78,0x1E,0xE6,0xF0,0xC6,0xC6,0x38
.db 0xFC,0x78,0xFC,0x78,0xFC,0xCC,0xCC,0xC6,0xC6,0xCC,0xFE,0x78,0xC0,0x78,0x10,0x00
.db 0x30,0x00,0xE0,0x00,0x1C,0x00,0x38,0x00,0xE0,0x30,0x0C,0xE0,0x70,0x00,0x00,0x00
.db 0x00,0x00,0x00,0x00,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x18,0xE0,0x76,0x00 
.db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x7E,0xCC,0xE0,0xCC,0x7C,0xE0,0xC6,0x30
.db 0x1C,0x00,0x3E,0x78,0x00,0x00,0x78,0x00,0x00,0xCC,0xCC,0x18,0x38,0xCC,0xF8,0x0E
.db 0xCC,0x38,0x00,0x00,0x00,0xFC,0x3C,0x38,0x30,0x00,0x00,0xC3,0xC3,0x18,0x00,0x00
.db 0x22,0x55,0xDB,0x18,0x18,0x18,0x36,0x00,0x00,0x36,0x36,0x00,0x36,0x36,0x18,0x00
.db 0x18,0x18,0x00,0x18,0x00,0x18,0x18,0x36,0x36,0x00,0x36,0x00,0x36,0x00,0x36,0x18
.db 0x36,0x00,0x00,0x36,0x18,0x00,0x00,0x36,0x18,0x18,0x00,0xFF,0x00,0xF0,0x0F,0xFF
.db 0x00,0x00,0x00,0x00,0xFC,0x00,0x00,0x00,0xFC,0x38,0x38,0x1C,0x00,0x06,0x38,0x78
.db 0x00,0x30,0x60,0x18,0x0E,0x18,0x30,0x00,0x38,0x00,0x00,0x0F,0x78,0x70,0x00,0x00
px2:
.db 0x00,0x81,0xFF,0xFE,0x38,0x7C,0x10,0x10,0xFF,0x00,0x00,0x00,0x00,0x00,0x63,0x5A
.db 0xE0,0x0E,0x3C,0x66,0xDB,0x63,0x00,0x3C,0x3C,0x18,0x18,0x30,0x30,0x30,0x30,0x30
.db 0x00,0x78,0x6C,0x6C,0x7C,0xC6,0x6C,0x60,0x30,0x30,0x66,0x30,0x00,0x00,0x00,0x0C
.db 0xC6,0x70,0xCC,0xCC,0x3C,0xC0,0x60,0xCC,0xCC,0xCC,0x30,0x30,0x30,0x00,0x30,0xCC
.db 0xC6,0x78,0x66,0x66,0x6C,0x62,0x62,0x66,0xCC,0x30,0x0C,0x66,0x60,0xEE,0xE6,0x6C
.db 0x66,0xCC,0x66,0xCC,0xB4,0xCC,0xCC,0xC6,0xC6,0xCC,0xC6,0x60,0x60,0x18,0x38,0x00
.db 0x30,0x00,0x60,0x00,0x0C,0x00,0x6C,0x00,0x60,0x00,0x00,0x60,0x30,0x00,0x00,0x00
.db 0x00,0x00,0x00,0x00,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x18,0x30,0xDC,0x10
.db 0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xC3,0x00,0x00,0x00,0xC6,0x00,0x38,0x30
.db 0x00,0x00,0x6C,0xCC,0xCC,0xE0,0xCC,0xCC,0xCC,0x18,0x00,0x18,0x6C,0xCC,0xCC,0x1B
.db 0x00,0x00,0x1C,0x1C,0xF8,0x00,0x6C,0x6C,0x00,0x00,0x00,0xC6,0xC6,0x18,0x33,0xCC
.db 0x88,0xAA,0x77,0x18,0x18,0x18,0x36,0x00,0x00,0x36,0x36,0x00,0x36,0x36,0x18,0x00
.db 0x18,0x18,0x00,0x18,0x00,0x18,0x18,0x36,0x36,0x00,0x36,0x00,0x36,0x00,0x36,0x18
.db 0x36,0x00,0x00,0x36,0x18,0x00,0x00,0x36,0x18,0x18,0x00,0xFF,0x00,0xF0,0x0F,0xFF
.db 0x00,0x78,0xFC,0xFE,0xCC,0x00,0x66,0x76,0x30,0x6C,0x6C,0x30,0x00,0x0C,0x60,0xCC
.db 0xFC,0x30,0x30,0x30,0x1B,0x18,0x30,0x76,0x6C,0x00,0x00,0x0C,0x6C,0x18,0x00,0x00
px3:
.db 0x00,0xA5,0xDB,0xFE,0x7C,0x38,0x38,0x38,0xE7,0x00,0x00,0x00,0x00,0x00,0x7F,0x3C
.db 0xF8,0x3E,0x7E,0x66,0xDB,0x38,0x00,0x7E,0x7E,0x18,0x0C,0x60,0x60,0x60,0x60,0x60
.db 0x00,0x78,0x6C,0xFE,0xC0,0xCC,0x38,0xC0,0x60,0x18,0x3C,0x30,0x00,0x00,0x00,0x18
.db 0xCE,0x30,0x0C,0x0C,0x6C,0xF8,0xC0,0x0C,0xCC,0xCC,0x30,0x30,0x60,0xFC,0x18,0x0C
.db 0xDE,0xCC,0x66,0xC0,0x66,0x68,0x68,0xC0,0xCC,0x30,0x0C,0x6C,0x60,0xFE,0xF6,0xC6
.db 0x66,0xCC,0x66,0xE0,0x30,0xCC,0xCC,0xC6,0x6C,0xCC,0x8C,0x60,0x30,0x18,0x6C,0x00
.db 0x18,0x78,0x60,0x78,0x0C,0x78,0x60,0x76,0x6C,0x70,0x0C,0x66,0x30,0xCC,0xF8,0x78
.db 0xDC,0x76,0xDC,0x7C,0x7C,0xCC,0xCC,0xC6,0xC6,0xCC,0xFC,0x30,0x18,0x30,0x00,0x38
.db 0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0x3C,0x78,0x78,0x70,0x38,0x70,0x6C,0x00
.db 0xFC,0x7F,0xCC,0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0xCC,0x7E,0x64,0x78,0xCC,0x18
.db 0x78,0x70,0x00,0x00,0x00,0xCC,0x6C,0x6C,0x30,0x00,0x00,0xCC,0xCC,0x00,0x66,0x66
.db 0x22,0x55,0xDB,0x18,0x18,0xF8,0x36,0x00,0xF8,0xF6,0x36,0xFE,0xF6,0x36,0xF8,0x00
.db 0x18,0x18,0x00,0x18,0x00,0x18,0x1F,0x36,0x37,0x3F,0xF7,0xFF,0x37,0xFF,0xF7,0xFF
.db 0x36,0xFF,0x00,0x36,0x1F,0x1F,0x00,0x36,0xFF,0x18,0x00,0xFF,0x00,0xF0,0x0F,0xFF
.db 0x76,0xCC,0xCC,0x6C,0x60,0x7E,0x66,0xDC,0x78,0xC6,0xC6,0x18,0x7E,0x7E,0xC0,0xCC
.db 0x00,0xFC,0x18,0x60,0x1B,0x18,0x00,0xDC,0x6C,0x00,0x00,0x0C,0x6C,0x30,0x3C,0x00
px4:
.db 0x00,0x81,0xFF,0xFE,0xFE,0xFE,0x7C,0x7C,0xC3,0x00,0x00,0x00,0x00,0x00,0x63,0xE7
.db 0xFE,0xFE,0x18,0x66,0x7B,0x6C,0x00,0x18,0x18,0x18,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE
.db 0x00,0x30,0x00,0x6C,0x78,0x18,0x76,0x00,0x60,0x18,0xFF,0xFC,0x00,0xFC,0x00,0x30
.db 0xDE,0x30,0x38,0x38,0xCC,0x0C,0xF8,0x18,0x78,0x7C,0x00,0x00,0xC0,0x00,0x0C,0x18
.db 0xDE,0xCC,0x7C,0xC0,0x66,0x78,0x78,0xC0,0xFC,0x30,0x0C,0x78,0x60,0xFE,0xDE,0xC6
.db 0x7C,0xCC,0x7C,0x70,0x30,0xCC,0xCC,0xD6,0x38,0x78,0x18,0x60,0x18,0x18,0xC6,0x00
.db 0x00,0x0C,0x7C,0xCC,0x7C,0xCC,0xF0,0xCC,0x76,0x30,0x0C,0x6C,0x30,0xFE,0xCC,0xCC
.db 0x66,0xCC,0x76,0xC0,0x30,0xCC,0xCC,0xD6,0x6C,0xCC,0x98,0xE0,0x00,0x1C,0x00,0x6C
.db 0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0x66,0xCC,0xCC,0x30,0x18,0x30,0xC6,0x78
.db 0x60,0x0C,0xFE,0x78,0x78,0x78,0xCC,0xCC,0xCC,0x66,0xCC,0xC0,0xF0,0xFC,0xFA,0x3C
.db 0x0C,0x30,0x78,0xCC,0xF8,0xEC,0x3E,0x38,0x60,0xFC,0xFC,0xDE,0xDB,0x18,0xCC,0x33
.db 0x88,0xAA,0xEE,0x18,0x18,0x18,0x36,0x00,0x18,0x06,0x36,0x06,0x06,0x36,0x18,0x00
.db 0x18,0x18,0x00,0x18,0x00,0x18,0x18,0x36,0x30,0x30,0x00,0x00,0x30,0x00,0x00,0x00
.db 0x36,0x00,0x00,0x36,0x18,0x18,0x00,0x36,0x18,0x18,0x00,0xFF,0x00,0xF0,0x0F,0xFF
.db 0xDC,0xF8,0xC0,0x6C,0x30,0xD8,0x66,0x18,0xCC,0xFE,0xC6,0x7C,0xDB,0xDB,0xF8,0xCC
.db 0xFC,0x30,0x30,0x30,0x18,0x18,0xFC,0x00,0x38,0x18,0x00,0x0C,0x6C,0x60,0x3C,0x00
px5:
.db 0x00,0xBD,0xC3,0x7C,0x7C,0xFE,0xFE,0xFE,0xC3,0x00,0x00,0x00,0x00,0x00,0x63,0xE7
.db 0xF8,0x3E,0x18,0x66,0x1B,0x6C,0x7E,0x7E,0x18,0x7E,0x0C,0x60,0x60,0x60,0x60,0x60
.db 0x00,0x30,0x00,0xFE,0x0C,0x30,0xDC,0x00,0x60,0x18,0x3C,0x30,0x00,0x00,0x00,0x60
.db 0xF6,0x30,0x60,0x0C,0xFE,0x0C,0xCC,0x30,0xCC,0x0C,0x00,0x00,0x60,0x00,0x18,0x30
.db 0xDE,0xFC,0x66,0xC0,0x66,0x68,0x68,0xCE,0xCC,0x30,0xCC,0x6C,0x62,0xD6,0xCE,0xC6
.db 0x60,0xDC,0x6C,0x1C,0x30,0xCC,0xCC,0xFE,0x38,0x30,0x32,0x60,0x0C,0x18,0x00,0x00
.db 0x00,0x7C,0x66,0xC0,0xCC,0xFC,0x60,0xCC,0x66,0x30,0x0C,0x78,0x30,0xFE,0xCC,0xCC
.db 0x66,0xCC,0x66,0x78,0x30,0xCC,0xCC,0xFE,0x38,0xCC,0x30,0x30,0x18,0x30,0x00,0xC6
.db 0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0x7E,0xFC,0xFC,0x30,0x18,0x30,0xFE,0xCC
.db 0x78,0x7F,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0x66,0xCC,0xC0,0x60,0x30,0xC6,0x18
.db 0x7C,0x30,0xCC,0xCC,0xCC,0xFC,0x00,0x00,0xC0,0xC0,0x0C,0x33,0x37,0x18,0x66,0x66
.db 0x22,0x55,0xDB,0x18,0xF8,0xF8,0xF6,0xFE,0xF8,0xF6,0x36,0xF6,0xFE,0xFE,0xF8,0xF8
.db 0x1F,0xFF,0xFF,0x1F,0xFF,0xFF,0x1F,0x37,0x3F,0x37,0xFF,0xF7,0x37,0xFF,0xF7,0xFF
.db 0xFF,0xFF,0xFF,0x3F,0x1F,0x1F,0x3F,0xFF,0xFF,0xF8,0x1F,0xFF,0xFF,0xF0,0x0F,0x00
.db 0xC8,0xCC,0xC0,0x6C,0x60,0xD8,0x66,0x18,0xCC,0xC6,0x6C,0xCC,0xDB,0xDB,0xC0,0xCC
.db 0x00,0x30,0x60,0x18,0x18,0x18,0x00,0x76,0x00,0x18,0x18,0xEC,0x6C,0x78,0x3C,0x00
px6:
.db 0x00,0x99,0xE7,0x38,0x38,0x7C,0x7C,0x7C,0xE7,0x00,0x00,0x00,0x00,0x00,0x67,0x3C
.db 0xE0,0x0E,0x7E,0x00,0x1B,0x38,0x7E,0x3C,0x18,0x3C,0x18,0x30,0x30,0x30,0x30,0x30
.db 0x00,0x00,0x00,0x6C,0xF8,0x66,0xCC,0x00,0x30,0x30,0x66,0x30,0x30,0x00,0x30,0xC0
.db 0xE6,0x30,0xCC,0xCC,0x0C,0xCC,0xCC,0x30,0xCC,0x18,0x30,0x30,0x30,0xFC,0x30,0x00
.db 0xC0,0xCC,0x66,0x66,0x6C,0x62,0x60,0x66,0xCC,0x30,0xCC,0x66,0x66,0xC6,0xC6,0x6C
.db 0x60,0x78,0x66,0xCC,0x30,0xCC,0x78,0xEE,0x6C,0x30,0x66,0x60,0x06,0x18,0x00,0x00
.db 0x00,0xCC,0x66,0xCC,0xCC,0xC0,0x60,0x7C,0x66,0x30,0xCC,0x6C,0x30,0xD6,0xCC,0xCC
.db 0x7C,0x7C,0x60,0x0C,0x34,0xCC,0x78,0xFE,0x6C,0x7C,0x64,0x30,0x18,0x30,0x00,0xC6
.db 0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x60,0xC0,0xC0,0x30,0x18,0x30,0xC6,0xFC
.db 0x60,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0x7C,0x3C,0xCC,0x7E,0xE6,0xFC,0xCF,0x18
.db 0xCC,0x30,0xCC,0xCC,0xCC,0xDC,0x7E,0x7C,0xCC,0xC0,0x0C,0x66,0x6F,0x18,0x33,0xCC
.db 0x88,0xAA,0x77,0x18,0x18,0x18,0x36,0x36,0x18,0x36,0x36,0x36,0x00,0x00,0x00,0x18
.db 0x00,0x00,0x18,0x18,0x00,0x18,0x18,0x36,0x00,0x36,0x00,0x36,0x36,0x00,0x36,0x00
.db 0x00,0x18,0x36,0x00,0x00,0x18,0x36,0x36,0x18,0x00,0x18,0xFF,0xFF,0xF0,0x0F,0x00
.db 0xDC,0xF8,0xC0,0x6C,0xCC,0xD8,0x7C,0x18,0x78,0x6C,0x6C,0xCC,0x7E,0x7E,0x60,0xCC
.db 0xFC,0x00,0x00,0x00,0x18,0xD8,0x30,0xDC,0x00,0x00,0x00,0x6C,0x00,0x00,0x3C,0x00
px7:
.db 0x00,0x81,0xFF,0x10,0x10,0x38,0x38,0x38,0xFF,0x00,0x00,0x00,0x00,0x00,0xE6,0x5A
.db 0x80,0x02,0x3C,0x66,0x1B,0xCC,0x7E,0x18,0x18,0x18,0x00,0x00,0x00,0x00,0x00,0x00
.db 0x00,0x30,0x00,0x6C,0x30,0xC6,0x76,0x00,0x18,0x60,0x00,0x00,0x30,0x00,0x30,0x80
.db 0x7C,0xFC,0xFC,0x78,0x1E,0x78,0x78,0x30,0x78,0x70,0x30,0x30,0x18,0x00,0x60,0x30
.db 0x78,0xCC,0xFC,0x3C,0xF8,0xFE,0xF0,0x3E,0xCC,0x78,0x78,0xE6,0xFE,0xC6,0xC6,0x38
.db 0xF0,0x1C,0xE6,0x78,0x78,0xFC,0x30,0xC6,0xC6,0x78,0xFE,0x78,0x02,0x78,0x00,0x00
.db 0x00,0x76,0xDC,0x78,0x76,0x78,0xF0,0x0C,0xE6,0x78,0xCC,0xE6,0x78,0xC6,0xCC,0x78
.db 0x60,0x0C,0xF0,0xF8,0x18,0x76,0x30,0x6C,0xC6,0x0C,0xFC,0x1C,0x18,0xE0,0x00,0xFE
.db 0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x3C,0x78,0x78,0x78,0x3C,0x78,0xC6,0xCC
.db 0xFC,0x7F,0xCE,0x78,0x78,0x78,0x7E,0x7E,0x0C,0x18,0x78,0x18,0xFC,0x30,0xC6,0xD8
.db 0x7E,0x78,0x78,0x7E,0xCC,0xCC,0x00,0x00,0x78,0x00,0x00,0xCC,0xCF,0x18,0x00,0x00
.db 0x22,0x55,0xDB,0x18,0x18,0x18,0x36,0x36,0x18,0x36,0x36,0x36,0x00,0x00,0x00,0x18
.db 0x00,0x00,0x18,0x18,0x00,0x18,0x18,0x36,0x00,0x36,0x00,0x36,0x36,0x00,0x36,0x00
.db 0x00,0x18,0x36,0x00,0x00,0x18,0x36,0x36,0x18,0x00,0x18,0xFF,0xFF,0xF0,0x0F,0x00
.db 0x76,0xC0,0xC0,0x6C,0xFC,0x70,0x60,0x18,0x30,0x38,0xEE,0x78,0x00,0x60,0x38,0xCC
.db 0x00,0xFC,0xFC,0xFC,0x18,0xD8,0x30,0x00,0x00,0x00,0x00,0x3C,0x00,0x00,0x00,0x00
px8:
.db 0x00,0x7E,0x7E,0x00,0x00,0x7C,0x7C,0x7C,0xFF,0x00,0x00,0x00,0x00,0x00,0xC0,0x99
.db 0x00,0x00,0x18,0x00,0x00,0x78,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
.db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x00,0x00
.db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x00,0x00,0x00
.db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
.db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF
.db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF8,0x00,0x00,0x78,0x00,0x00,0x00,0x00,0x00
.db 0xF0,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF8,0x00,0x00,0x00,0x00,0x00,0x00
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
.db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF8,0x00,0x00,0x18,0x00,0x30,0xC7,0x70
.db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x03,0x00,0x00,0x00
.db 0x88,0xAA,0xEE,0x18,0x18,0x18,0x36,0x36,0x18,0x36,0x36,0x36,0x00,0x00,0x00,0x18
.db 0x00,0x00,0x18,0x18,0x00,0x18,0x18,0x36,0x00,0x36,0x00,0x36,0x36,0x00,0x36,0x00
.db 0x00,0x18,0x36,0x00,0x00,0x18,0x36,0x36,0x18,0x00,0x18,0xFF,0xFF,0xF0,0x0F,0x00
.db 0x00,0xC0,0x00,0x00,0x00,0x00,0xC0,0x00,0xFC,0x00,0x00,0x00,0x00,0xC0,0x00,0x00
.db 0x00,0x00,0x00,0x00,0x18,0x70,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x00,0x00,0x00
#else
px1:
.db 0x00,0x7E,0x7E,0x6C,0x10,0x38,0x10,0x10,0xFF,0x00,0x00,0x00,0x00,0x00,0x7F,0x99
.db 0x80,0x02,0x18,0x66,0x7F,0x3E,0x00,0x18,0x18,0x18,0x00,0x00,0x00,0x00,0x00,0x00
.db 0x00,0x30,0x6C,0x6C,0x30,0x00,0x38,0x60,0x18,0x60,0x00,0x00,0x00,0x00,0x00,0x06
.db 0x7C,0x30,0x78,0x78,0x1C,0xFC,0x38,0xFC,0x78,0x78,0x00,0x00,0x18,0x00,0x60,0x78
.db 0x7C,0x30,0xFC,0x3C,0xF8,0xFE,0xFE,0x3C,0xCC,0x78,0x1E,0xE6,0xF0,0xC6,0xC6,0x38
.db 0xFC,0x78,0xFC,0x78,0xFC,0xCC,0xCC,0xC6,0xC6,0xCC,0xFE,0x78,0xC0,0x78,0x10,0x00
.db 0x30,0x00,0xE0,0x00,0x1C,0x00,0x38,0x00,0xE0,0x30,0x0C,0xE0,0x70,0x00,0x00,0x00
.db 0x00,0x00,0x00,0x00,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x18,0xE0,0x76,0x00
.db 0x78,0x00,0x1C,0x7E,0xCC,0xE0,0x30,0x00,0x7E,0xCC,0xE0,0xCC,0x7C,0xE0,0xC6,0x30
.db 0x1C,0x00,0x3E,0x78,0x00,0x00,0x78,0x00,0x00,0xC3,0xCC,0x18,0x38,0xCC,0xF8,0x0E
.db 0x1C,0x38,0x00,0x00,0x00,0xFC,0x3C,0x38,0x30,0x00,0x00,0xC3,0xC3,0x18,0x00,0x00
.db 0x22,0x55,0xDB,0x18,0x18,0x18,0x36,0x00,0x00,0x36,0x36,0x00,0x36,0x36,0x18,0x00
.db 0x18,0x18,0x00,0x18,0x00,0x18,0x18,0x36,0x36,0x00,0x36,0x00,0x36,0x00,0x36,0x18
.db 0x36,0x00,0x00,0x36,0x18,0x00,0x00,0x36,0x18,0x18,0x00,0xFF,0x00,0xF0,0x0F,0xFF
.db 0x00,0x00,0x00,0x00,0xFC,0x00,0x00,0x00,0xFC,0x38,0x38,0x1C,0x00,0x06,0x38,0x78
.db 0x00,0x30,0x60,0x18,0x0E,0x18,0x30,0x00,0x38,0x00,0x00,0x0F,0x78,0x70,0x00,0x00
px2:
.db 0x00,0x81,0xFF,0xFE,0x38,0x7C,0x10,0x10,0xFF,0x00,0x00,0x00,0x00,0x00,0x63,0x5A
.db 0xE0,0x0E,0x3C,0x66,0xDB,0x63,0x00,0x3C,0x3C,0x18,0x18,0x30,0x30,0x30,0x30,0x30
.db 0x00,0x78,0x6C,0x6C,0x7C,0xC6,0x6C,0x60,0x30,0x30,0x66,0x30,0x00,0x00,0x00,0x0C
.db 0xC6,0x70,0xCC,0xCC,0x3C,0xC0,0x60,0xCC,0xCC,0xCC,0x30,0x30,0x30,0x00,0x30,0xCC
.db 0xC6,0x78,0x66,0x66,0x6C,0x62,0x62,0x66,0xCC,0x30,0x0C,0x66,0x60,0xEE,0xE6,0x6C
.db 0x66,0xCC,0x66,0xCC,0xB4,0xCC,0xCC,0xC6,0xC6,0xCC,0xC6,0x60,0x60,0x18,0x38,0x00
.db 0x30,0x00,0x60,0x00,0x0C,0x00,0x6C,0x00,0x60,0x00,0x00,0x60,0x30,0x00,0x00,0x00
.db 0x00,0x00,0x00,0x00,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x18,0x30,0xDC,0x10
.db 0xCC,0xCC,0x00,0xC3,0x00,0x00,0x30,0x00,0xC3,0x00,0x00,0x00,0xC6,0x00,0x38,0x30
.db 0x00,0x00,0x6C,0xCC,0xCC,0xE0,0xCC,0xE0,0xCC,0x18,0x00,0x18,0x6C,0xCC,0xCC,0x1B
.db 0x00,0x00,0x1C,0x1C,0xF8,0x00,0x6C,0x6C,0x00,0x00,0x00,0xC6,0xC6,0x18,0x33,0xCC
.db 0x88,0xAA,0x77,0x18,0x18,0x18,0x36,0x00,0x00,0x36,0x36,0x00,0x36,0x36,0x18,0x00
.db 0x18,0x18,0x00,0x18,0x00,0x18,0x18,0x36,0x36,0x00,0x36,0x00,0x36,0x00,0x36,0x18
.db 0x36,0x00,0x00,0x36,0x18,0x00,0x00,0x36,0x18,0x18,0x00,0xFF,0x00,0xF0,0x0F,0xFF
.db 0x00,0x78,0xFC,0xFE,0xCC,0x00,0x66,0x76,0x30,0x6C,0x6C,0x30,0x00,0x0C,0x60,0xCC
.db 0xFC,0x30,0x30,0x30,0x1B,0x18,0x30,0x76,0x6C,0x00,0x00,0x0C,0x6C,0x18,0x00,0x00
px3:
.db 0x00,0xA5,0xDB,0xFE,0x7C,0x38,0x38,0x38,0xE7,0x00,0x00,0x00,0x00,0x00,0x7F,0x3C
.db 0xF8,0x3E,0x7E,0x66,0xDB,0x38,0x00,0x7E,0x7E,0x18,0x0C,0x60,0x60,0x60,0x60,0x60
.db 0x00,0x78,0x6C,0xFE,0xC0,0xCC,0x38,0xC0,0x60,0x18,0x3C,0x30,0x00,0x00,0x00,0x18
.db 0xCE,0x30,0x0C,0x0C,0x6C,0xF8,0xC0,0x0C,0xCC,0xCC,0x30,0x30,0x60,0xFC,0x18,0x0C
.db 0xDE,0xCC,0x66,0xC0,0x66,0x68,0x68,0xC0,0xCC,0x30,0x0C,0x6C,0x60,0xFE,0xF6,0xC6
.db 0x66,0xCC,0x66,0xE0,0x30,0xCC,0xCC,0xC6,0x6C,0xCC,0x8C,0x60,0x30,0x18,0x6C,0x00
.db 0x18,0x78,0x60,0x78,0x0C,0x78,0x60,0x76,0x6C,0x70,0x0C,0x66,0x30,0xCC,0xF8,0x78
.db 0xDC,0x76,0xDC,0x7C,0x7C,0xCC,0xCC,0xC6,0xC6,0xCC,0xFC,0x30,0x18,0x30,0x00,0x38
.db 0xC0,0x00,0x78,0x3C,0x78,0x78,0x78,0x78,0x3C,0x78,0x78,0x70,0x38,0x70,0x6C,0x00
.db 0xFC,0x7F,0xCC,0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0xCC,0x7E,0x64,0x78,0xCC,0x18
.db 0x78,0x70,0x00,0x00,0x00,0xCC,0x6C,0x6C,0x30,0x00,0x00,0xCC,0xCC,0x00,0x66,0x66
.db 0x22,0x55,0xDB,0x18,0x18,0xF8,0x36,0x00,0xF8,0xF6,0x36,0xFE,0xF6,0x36,0xF8,0x00
.db 0x18,0x18,0x00,0x18,0x00,0x18,0x1F,0x36,0x37,0x3F,0xF7,0xFF,0x37,0xFF,0xF7,0xFF
.db 0x36,0xFF,0x00,0x36,0x1F,0x1F,0x00,0x36,0xFF,0x18,0x00,0xFF,0x00,0xF0,0x0F,0xFF
.db 0x76,0xCC,0xCC,0x6C,0x60,0x7E,0x66,0xDC,0x78,0xC6,0xC6,0x18,0x7E,0x7E,0xC0,0xCC
.db 0x00,0xFC,0x18,0x60,0x1B,0x18,0x00,0xDC,0x6C,0x00,0x00,0x0C,0x6C,0x30,0x3C,0x00
px4:
.db 0x00,0x81,0xFF,0xFE,0xFE,0xFE,0x7C,0x7C,0xC3,0x00,0x00,0x00,0x00,0x00,0x63,0xE7
.db 0xFE,0xFE,0x18,0x66,0x7B,0x6C,0x00,0x18,0x18,0x18,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE
.db 0x00,0x30,0x00,0x6C,0x78,0x18,0x76,0x00,0x60,0x18,0xFF,0xFC,0x00,0xFC,0x00,0x30
.db 0xDE,0x30,0x38,0x38,0xCC,0x0C,0xF8,0x18,0x78,0x7C,0x00,0x00,0xC0,0x00,0x0C,0x18
.db 0xDE,0xCC,0x7C,0xC0,0x66,0x78,0x78,0xC0,0xFC,0x30,0x0C,0x78,0x60,0xFE,0xDE,0xC6
.db 0x7C,0xCC,0x7C,0x70,0x30,0xCC,0xCC,0xD6,0x38,0x78,0x18,0x60,0x18,0x18,0xC6,0x00
.db 0x00,0x0C,0x7C,0xCC,0x7C,0xCC,0xF0,0xCC,0x76,0x30,0x0C,0x6C,0x30,0xFE,0xCC,0xCC
.db 0x66,0xCC,0x76,0xC0,0x30,0xCC,0xCC,0xD6,0x6C,0xCC,0x98,0xE0,0x00,0x1C,0x00,0x6C
.db 0xCC,0xCC,0xCC,0x06,0x0C,0x0C,0x0C,0xC0,0x66,0xCC,0xCC,0x30,0x18,0x30,0xC6,0x78
.db 0x60,0x0C,0xFE,0x78,0x78,0x78,0xCC,0xCC,0xCC,0x66,0xCC,0xC0,0xF0,0xFC,0xFA,0x3C
.db 0x0C,0x30,0x78,0xCC,0xF8,0xEC,0x3E,0x38,0x60,0xFC,0xFC,0xDE,0xDB,0x18,0xCC,0x33
.db 0x88,0xAA,0xEE,0x18,0x18,0x18,0x36,0x00,0x18,0x06,0x36,0x06,0x06,0x36,0x18,0x00
.db 0x18,0x18,0x00,0x18,0x00,0x18,0x18,0x36,0x30,0x30,0x00,0x00,0x30,0x00,0x00,0x00
.db 0x36,0x00,0x00,0x36,0x18,0x18,0x00,0x36,0x18,0x18,0x00,0xFF,0x00,0xF0,0x0F,0xFF
.db 0xDC,0xF8,0xC0,0x6C,0x30,0xD8,0x66,0x18,0xCC,0xFE,0xC6,0x7C,0xDB,0xDB,0xF8,0xCC
.db 0xFC,0x30,0x30,0x30,0x18,0x18,0xFC,0x00,0x38,0x18,0x00,0x0C,0x6C,0x60,0x3C,0x00
px5:
.db 0x00,0xBD,0xC3,0x7C,0x7C,0xFE,0xFE,0xFE,0xC3,0x00,0x00,0x00,0x00,0x00,0x63,0xE7
.db 0xF8,0x3E,0x18,0x66,0x1B,0x6C,0x7E,0x7E,0x18,0x7E,0x0C,0x60,0x60,0x60,0x60,0x60
.db 0x00,0x30,0x00,0xFE,0x0C,0x30,0xDC,0x00,0x60,0x18,0x3C,0x30,0x00,0x00,0x00,0x60
.db 0xF6,0x30,0x60,0x0C,0xFE,0x0C,0xCC,0x30,0xCC,0x0C,0x00,0x00,0x60,0x00,0x18,0x30
.db 0xDE,0xFC,0x66,0xC0,0x66,0x68,0x68,0xCE,0xCC,0x30,0xCC,0x6C,0x62,0xD6,0xCE,0xC6
.db 0x60,0xDC,0x6C,0x1C,0x30,0xCC,0xCC,0xFE,0x38,0x30,0x32,0x60,0x0C,0x18,0x00,0x00
.db 0x00,0x7C,0x66,0xC0,0xCC,0xFC,0x60,0xCC,0x66,0x30,0x0C,0x78,0x30,0xFE,0xCC,0xCC
.db 0x66,0xCC,0x66,0x78,0x30,0xCC,0xCC,0xFE,0x38,0xCC,0x30,0x30,0x18,0x30,0x00,0xC6
.db 0x78,0xCC,0xFC,0x3E,0x7C,0x7C,0x7C,0xC0,0x7E,0xFC,0xFC,0x30,0x18,0x30,0xFE,0xCC
.db 0x78,0x7F,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0x66,0xCC,0xC0,0x60,0x30,0xC6,0x18
.db 0x7C,0x30,0xCC,0xCC,0xCC,0xFC,0x00,0x00,0xC0,0xC0,0x0C,0x33,0x37,0x18,0x66,0x66
.db 0x22,0x55,0xDB,0x18,0xF8,0xF8,0xF6,0xFE,0xF8,0xF6,0x36,0xF6,0xFE,0xFE,0xF8,0xF8
.db 0x1F,0xFF,0xFF,0x1F,0xFF,0xFF,0x1F,0x37,0x3F,0x37,0xFF,0xF7,0x37,0xFF,0xF7,0xFF
.db 0xFF,0xFF,0xFF,0x3F,0x1F,0x1F,0x3F,0xFF,0xFF,0xF8,0x1F,0xFF,0xFF,0xF0,0x0F,0x00
.db 0xC8,0xCC,0xC0,0x6C,0x60,0xD8,0x66,0x18,0xCC,0xC6,0x6C,0xCC,0xDB,0xDB,0xC0,0xCC
.db 0x00,0x30,0x60,0x18,0x18,0x18,0x00,0x76,0x00,0x18,0x18,0xEC,0x6C,0x78,0x3C,0x00
px6:
.db 0x00,0x99,0xE7,0x38,0x38,0x7C,0x7C,0x7C,0xE7,0x00,0x00,0x00,0x00,0x00,0x67,0x3C
.db 0xE0,0x0E,0x7E,0x00,0x1B,0x38,0x7E,0x3C,0x18,0x3C,0x18,0x30,0x30,0x30,0x30,0x30
.db 0x00,0x00,0x00,0x6C,0xF8,0x66,0xCC,0x00,0x30,0x30,0x66,0x30,0x30,0x00,0x30,0xC0
.db 0xE6,0x30,0xCC,0xCC,0x0C,0xCC,0xCC,0x30,0xCC,0x18,0x30,0x30,0x30,0xFC,0x30,0x00
.db 0xC0,0xCC,0x66,0x66,0x6C,0x62,0x60,0x66,0xCC,0x30,0xCC,0x66,0x66,0xC6,0xC6,0x6C
.db 0x60,0x78,0x66,0xCC,0x30,0xCC,0x78,0xEE,0x6C,0x30,0x66,0x60,0x06,0x18,0x00,0x00
.db 0x00,0xCC,0x66,0xCC,0xCC,0xC0,0x60,0x7C,0x66,0x30,0xCC,0x6C,0x30,0xD6,0xCC,0xCC
.db 0x7C,0x7C,0x60,0x0C,0x34,0xCC,0x78,0xFE,0x6C,0x7C,0x64,0x30,0x18,0x30,0x00,0xC6
.db 0x18,0xCC,0xC0,0x66,0xCC,0xCC,0xCC,0x78,0x60,0xC0,0xC0,0x30,0x18,0x30,0xC6,0xFC
.db 0x60,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0x7C,0x3C,0xCC,0x7E,0xE6,0xFC,0xCF,0x18
.db 0xCC,0x30,0xCC,0xCC,0xCC,0xDC,0x7E,0x7C,0xCC,0xC0,0x0C,0x66,0x6F,0x18,0x33,0xCC
.db 0x88,0xAA,0x77,0x18,0x18,0x18,0x36,0x36,0x18,0x36,0x36,0x36,0x00,0x00,0x00,0x18
.db 0x00,0x00,0x18,0x18,0x00,0x18,0x18,0x36,0x00,0x36,0x00,0x36,0x36,0x00,0x36,0x00
.db 0x00,0x18,0x36,0x00,0x00,0x18,0x36,0x36,0x18,0x00,0x18,0xFF,0xFF,0xF0,0x0F,0x00
.db 0xDC,0xF8,0xC0,0x6C,0xCC,0xD8,0x7C,0x18,0x78,0x6C,0x6C,0xCC,0x7E,0x7E,0x60,0xCC
.db 0xFC,0x00,0x00,0x00,0x18,0xD8,0x30,0xDC,0x00,0x00,0x00,0x6C,0x00,0x00,0x3C,0x00
px7:
.db 0x00,0x81,0xFF,0x10,0x10,0x38,0x38,0x38,0xFF,0x00,0x00,0x00,0x00,0x00,0xE6,0x5A
.db 0x80,0x02,0x3C,0x66,0x1B,0xCC,0x7E,0x18,0x18,0x18,0x00,0x00,0x00,0x00,0x00,0x00
.db 0x00,0x30,0x00,0x6C,0x30,0xC6,0x76,0x00,0x18,0x60,0x00,0x00,0x30,0x00,0x30,0x80
.db 0x7C,0xFC,0xFC,0x78,0x1E,0x78,0x78,0x30,0x78,0x70,0x30,0x30,0x18,0x00,0x60,0x30
.db 0x78,0xCC,0xFC,0x3C,0xF8,0xFE,0xF0,0x3E,0xCC,0x78,0x78,0xE6,0xFE,0xC6,0xC6,0x38
.db 0xF0,0x1C,0xE6,0x78,0x78,0xFC,0x30,0xC6,0xC6,0x78,0xFE,0x78,0x02,0x78,0x00,0x00
.db 0x00,0x76,0xDC,0x78,0x76,0x78,0xF0,0x0C,0xE6,0x78,0xCC,0xE6,0x78,0xC6,0xCC,0x78
.db 0x60,0x0C,0xF0,0xF8,0x18,0x76,0x30,0x6C,0xC6,0x0C,0xFC,0x1C,0x18,0xE0,0x00,0xFE
.db 0x0C,0x7E,0x78,0x3F,0x7E,0x7E,0x7E,0x0C,0x3C,0x78,0x78,0x78,0x3C,0x78,0xC6,0xCC
.db 0xFC,0x7F,0xCE,0x78,0x78,0x78,0x7E,0x7E,0x0C,0x18,0x78,0x18,0xFC,0x30,0xC6,0xD8
.db 0x7E,0x78,0x78,0x7E,0xCC,0xCC,0x00,0x00,0x78,0x00,0x00,0xCC,0xCF,0x18,0x00,0x00
.db 0x22,0x55,0xDB,0x18,0x18,0x18,0x36,0x36,0x18,0x36,0x36,0x36,0x00,0x00,0x00,0x18
.db 0x00,0x00,0x18,0x18,0x00,0x18,0x18,0x36,0x00,0x36,0x00,0x36,0x36,0x00,0x36,0x00
.db 0x00,0x18,0x36,0x00,0x00,0x18,0x36,0x36,0x18,0x00,0x18,0xFF,0xFF,0xF0,0x0F,0x00
.db 0x76,0xC0,0xC0,0x6C,0xFC,0x70,0x60,0x18,0x30,0x38,0xEE,0x78,0x00,0x60,0x38,0xCC
.db 0x00,0xFC,0xFC,0xFC,0x18,0xD8,0x30,0x00,0x00,0x00,0x00,0x3C,0x00,0x00,0x00,0x00
px8:
.db 0x00,0x7E,0x7E,0x00,0x00,0x7C,0x7C,0x7C,0xFF,0x00,0x00,0x00,0x00,0x00,0xC0,0x99
.db 0x00,0x00,0x18,0x00,0x00,0x78,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
.db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x00,0x00
.db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x00,0x00,0x00
.db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
.db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF
.db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF8,0x00,0x00,0x78,0x00,0x00,0x00,0x00,0x00
.db 0xF0,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF8,0x00,0x00,0x00,0x00,0x00,0x00
.db 0x78,0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
.db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF8,0x00,0x00,0x18,0x00,0x30,0xC7,0x70
.db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x03,0x00,0x00,0x00
.db 0x88,0xAA,0xEE,0x18,0x18,0x18,0x36,0x36,0x18,0x36,0x36,0x36,0x00,0x00,0x00,0x18
.db 0x00,0x00,0x18,0x18,0x00,0x18,0x18,0x36,0x00,0x36,0x00,0x36,0x36,0x00,0x36,0x00
.db 0x00,0x18,0x36,0x00,0x00,0x18,0x36,0x36,0x18,0x00,0x18,0xFF,0xFF,0xF0,0x0F,0x00
.db 0x00,0xC0,0x00,0x00,0x00,0x00,0xC0,0x00,0xFC,0x00,0x00,0x00,0x00,0xC0,0x00,0x00
.db 0x00,0x00,0x00,0x00,0x18,0x70,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x00,0x00,0x00
#endif
px9:
;Fllpixelzeile fr Zeilenabstand
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
cgromend:
;Hier ist kein Platz mehr fr Konstanten oder Programm...
